import 'package:adeptutils/adeptutils.dart';
import 'package:rxdart/rxdart.dart';
import 'dart:async';

class AdeptPublishSubject<T> {
  dynamic id;
  AdeptController? valueNotifier;
  final PublishSubject<T?> _publishSubject;
  T? _value;
  T? get value => _value;

  AdeptPublishSubject({this.id, this.valueNotifier})
      : _publishSubject = PublishSubject<T>();

  void post(T? value) => _publishSubject.add(_value = value);
  Stream<T?> stream() => _publishSubject.stream;
  StreamSubscription<T?> listen(void Function(T? event) onData,
          {Function? onError, void Function()? onDone, bool? cancelOnError}) =>
      _publishSubject.stream.listen(onData,
          onError: onError, onDone: onDone, cancelOnError: cancelOnError);

  void close() => _publishSubject.close();

  @override
  int get hashCode => id?.hashCode ?? super.hashCode;

  @override
  bool operator ==(other) {
    if (other is! AdeptPublishSubject<T>) return false;
    if (id != null && other.id != null) return id == other.id;
    return value == other.value;
  }
}
